package com.example.droptik;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import java.io.IOException;
import java.util.UUID;

import io.github.controlwear.virtual.joystick.android.JoystickView;

public class Ovladac extends AppCompatActivity{
    //proměnné pro připojení Bluetooth
    private Button buttonOdpojBluetooth; //pro tlačítko na odpojení zařízení
    private TextView textViewStavPripojBluetooth; //pro zobrazení stavu připojení Bluetooth
    private BluetoothAdapter mBluetoothAdapter; //pro připojení přes Bluetooth
    private String adresaB = null; //
    private boolean jeBTPripojen = false; //ověření zda se povedlo propojit auto a ovladač
    private BluetoothSocket bluetoothSocket = null; //proměnná pro komunikaci přes bluetooth
    private static final UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805f9b34fb");

    //proměnné pro definování směru vřed vzad
    private JoystickView joystickDZ;
    private Button buttonStop;

    //proměnné pro definování směru do stran
    private JoystickView joystickVP;
    private SeekBar seekBarNaprava;
    private int hondotaSeekBaru;
    private TextView textSeekNaprava;
    private Button buttonOUhelVlevo;
    private Button buttonOUhelVpravo;
    private String smer;

    private Auto auto = new Auto(); //instance třídy Auto
    private Nabidka nabidka = new Nabidka(); //instance třídy Nabidka
    private PripojeniBluetooth pripojeniBluetooth = new PripojeniBluetooth();

    //metoda pro zobrazení všech komponent na obrazovku (něco jako metoda main v Javě)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState); //dědění prvků obecné aktivity
        setContentView(R.layout.activity_ovladac); //přiřazení XML souboru s designem

        //definování toolbaru pro umístění menu
        Toolbar toolbar = findViewById(R.id.toolOvladac);
        setSupportActionBar(toolbar);

        //přiřazení promšnných k design
        joystickDZ = findViewById(R.id.joystickViewPlyn);
        joystickVP = findViewById(R.id.joystickViewDoStran);
        seekBarNaprava = findViewById(R.id.seekHodNaprav);
        textSeekNaprava = findViewById(R.id.txtNaprava);
        buttonOUhelVlevo = findViewById(R.id.btnLevoR);
        buttonOUhelVpravo = findViewById(R.id.btnPravoR);
        buttonStop = findViewById(R.id.btnStop); //přiřazení proměnné tlačítku pro zastavení auta

        textViewStavPripojBluetooth = findViewById(R.id.lblStavBluetooth); //zobrazení stavu pčipojení

        //převzetí adresy propojeného zařízení
        Intent newint = getIntent(); //získání adresy zařízení z výběru
        adresaB = newint.getStringExtra(PripojeniBluetooth.EXTRA_ADDRESS_BLUETOOTH); //získání Bluetooth adresy zařízení

        //volání třídy pro připojení k zařízení přes Bluetooth
        // if je tu z důvodu aby šel zobrazit ovladač i když není připojené zařízení jinak aplikace spadne
        if (PripojeniBluetooth.sStartBluetooth == true) {
            new PripojBT().execute();
        }

        buttonOdpojBluetooth = findViewById(R.id.btnOdpojitBluetooth);

        //volba náklonu nápravy pro přímé natočení o daný úhel
        seekBarNaprava.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                hondotaSeekBaru = progress;
                textSeekNaprava.setText(progress + "stupňů");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
                //povinná metoda, nevyužitá
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                //povinná metoda, nevyužitá
            }
        });

        //volání metod pro ovládaní auta z třídy Auto
        //Pohyb do stran
        // if je tu z důvodu aby nešly volat metody když není připojené zařízení jinak aplikace spadne
        if (PripojeniBluetooth.sStartBluetooth == true) {
            //Listener, který dle hodnoty joysticku odešle signál pro pohyb vlevo a vpravo
            joystickVP.setOnMoveListener(new JoystickView.OnMoveListener() {
                @Override
                public void onMove(int uhel, int intenzita) {
                    if (uhel == 180 && intenzita == 100) { //jakmile se joystick nakloní k levému kraji
                        //volání metody třidy Auto pro zatočení doleva
                        smer = "doleva";
                        auto.zaboc(smer);

                    }
                    if (uhel == 0 && intenzita == 100) { //jakmile se joystick nakloní k pravému kraji
                        //volání metody třidy Auto pro zatočení doprava
                        smer = "doprava";
                        auto.zaboc(smer);
                    }
                }
            });
            buttonOUhelVlevo.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    smer = "doleva";
                    auto.zabocODanyUhel(hondotaSeekBaru, smer); //volání metody z třídy Auto, hondotaSeekBaru udává úhel zatočení, směr udává směr zatočení
                }
            });
            buttonOUhelVpravo.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    smer = "doprava";
                    auto.zabocODanyUhel(hondotaSeekBaru, smer);
                }
            });

            //Pohyb dopředu a dozadu
            //Listener, který dle hodnoty joysticku odešle signál pro pohyb vpřed a vzad
            joystickDZ.setOnMoveListener(new JoystickView.OnMoveListener() {
                @Override
                public void onMove(int uhel, int intenzita) {
                    if (uhel == 90 && intenzita == 50) {
                        smer = "dopredu";
                        auto.rozjedSe(smer);
                    }
                    if (uhel == 270 && intenzita == 50) {
                        smer = "dozadu";
                        auto.rozjedSe(smer);
                    }
                    if (uhel == 90 && intenzita == 100) {
                        smer = "dopreduPlna";
                        auto.rozjedSe(smer);
                    }
                    if (uhel == 270 && intenzita == 100) {
                        smer = "dozaduPlna";
                        auto.rozjedSe(smer);
                    }
                }
            });

            //zastavení auta
            buttonStop.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    auto.zastavSe();
                }
            });

            //odpojení Bluetooth
            buttonOdpojBluetooth.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    mBluetoothAdapter.disable();
                    textViewStavPripojBluetooth.setText("Nepřipojeno");
                    PripojeniBluetooth.seznamZarizeniBluetooth.setVisibility(View.INVISIBLE);//vymaž seznam zařízení
                    finish();
                    try {
                        bluetoothSocket.close();
                    } catch (IOException e) {
                        Toast toast = Toast.makeText(getApplicationContext(), "Problém s odpojením od Bluetooth!", Toast.LENGTH_LONG);
                        toast.show();
                    }
                }
            });
        } else {
            textViewStavPripojBluetooth.setText("Chyba \ns prijmem");
        }
    }

    //po zvolení prvku z menu přesun na metodu pro zobrazení konkrétní obrazovky
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.mePripojeni:
                nabidka.otevriPripojeniBluetooth();
                return true;
            case R.id.meOvladac:
                nabidka.otevriOvladac();
                return true;
            case R.id.meMapa:
                nabidka.otevriMapa();
                return true;
            case R.id.meZobrazeniSouradnic:
                nabidka.otevriZobrazeniSouradnicAuta();
                return true;
            case R.id.meAbout:
                nabidka.otevriAbout();
                return true;
            case R.id.meKonec:
                nabidka.ukoncitProgram();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }



    //vnitřní třída, která inicializuje důležité informace z aktivity pripojeniBluetooth
    public class PripojBT extends AsyncTask<Void, Void, Void> {
        private boolean pripojeniUspesneKbluetooth = true;

        @Override
        protected void onPreExecute() {
            //povinná metoda, nevyužitá
        }

        //na pozadí provádí připojení Bluetooth
        @Override
        protected Void doInBackground(Void... voids) {
            try {
                if (bluetoothSocket == null || !jeBTPripojen) {
                    mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
                    BluetoothDevice disDevice = mBluetoothAdapter.getRemoteDevice(adresaB);
                    bluetoothSocket = disDevice.createInsecureRfcommSocketToServiceRecord(uuid);
                    BluetoothAdapter.getDefaultAdapter().cancelDiscovery(); // zrušení vyhledávání dalšího zařízení, jelikož je již zařízení vybráno
                    bluetoothSocket.connect(); //start připojení
                }
            } catch (IOException e) {
                pripojeniUspesneKbluetooth = false;
            }
            return null;
        }

        //jakmile je provedena předešlá operace
        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            if (!pripojeniUspesneKbluetooth) {
                Toast toast = Toast.makeText(getApplicationContext(), "Připojení k Bluetooth selhalo. Zkuste znova zmáčknout Připojit!", Toast.LENGTH_LONG);
                toast.show();
                finish();
            } else {
                textViewStavPripojBluetooth.setText("Připojeno");
                jeBTPripojen = true;
            }
        }
    }
}

