package com.example.droptik;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Set;

public class PripojeniBluetooth extends AppCompatActivity {
    //deklarace globálních proměnných bluetooth
    private TextView textViewStavPripojBluetooth; //informace o stavu připojení
    public static ListView seznamZarizeniBluetooth; //seznam spárovaných zařízení
    private Button buttonPripojBluetooth;
    private Button buttonOdpojBluetooth;

    //proměnné pro připojení přes Bluetooth
    private BluetoothAdapter mBluetoothAdapter = null; //fyzický Bluetooth modul ovladače
    private Set<BluetoothDevice> sparovanaZarizeniBluetooth;
    private ArrayList zarizeniListBluetooth; //seznam zařízení v okolí
    public static String EXTRA_ADDRESS_BLUETOOTH = "device_adress";
    //proměnná z důvodu, aby šel zobrazit ovladač ik dyž není připojené zařízení static je aby šla volat v jiném okně (Aktivitě)
    public static boolean sStartBluetooth;

    private Nabidka nabidka = new Nabidka();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pripojeni_bluetooth);

        textViewStavPripojBluetooth = findViewById(R.id.lblStavPripojBluetooth);


        //Zobrazení toolbaru
        Toolbar toolbar = findViewById(R.id.toolPrehledBluetooth);
        setSupportActionBar(toolbar);

        //volání metody pro zobrazeni sparovaných zařízení přes Bluetooth
        buttonPripojBluetooth = findViewById(R.id.btnPripojBluetooth);
        seznamZarizeniBluetooth = findViewById(R.id.listWBluetooth);
        zapniBluetooth();

        buttonOdpojBluetooth = findViewById(R.id.btnOdpojBluetooth);
        if (sStartBluetooth == true) {
            odpojModel();
        }
    }

    //po zvolení prvku z menu přesun na metodu ze třídy Nabidka pro zobrazení konkrétní obrazovky
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.mePripojeni:
                nabidka.otevriPripojeniBluetooth();
                return true;
            case R.id.meOvladac:
                nabidka.otevriOvladac();
                return true;
            case R.id.meMapa:
                nabidka.otevriMapa();
                return true;
            case R.id.meZobrazeniSouradnic:
                nabidka.otevriZobrazeniSouradnicAuta();
                return true;
            case R.id.meAbout:
                nabidka.otevriAbout();
                return true;
            case R.id.meKonec:
                nabidka.ukoncitProgram();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    //metoda pro kontrolu a zapnutí Bluetooth
    private void zapniBluetooth() {
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter(); //Bluetooth adaptér zařízení ovladače
        buttonPripojBluetooth.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mBluetoothAdapter == null) { //ověření jestli je aplikace nainstalována na zařízení kde není Bluetooth k dispozici
                    Toast toast = Toast.makeText(getApplicationContext(), "Zařízení nepodporuje Bluetooth", Toast.LENGTH_LONG);
                    toast.show();
                    finish();//ukončit aplikaci
                }
                if (!mBluetoothAdapter.isEnabled()) { //pokud je Bluetooth zrovna vypnutý
                    textViewStavPripojBluetooth.setText("Nepřipojeno");
                    Intent intentBluetooth = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE); //zapnutí Bluetooth
                    startActivityForResult(intentBluetooth, 1);
                    textViewStavPripojBluetooth.setText("Stiskněte znova na Připojit");
                }
                if (mBluetoothAdapter.isEnabled()) {
                    seznamZarizeniBluetooth.setVisibility(View.VISIBLE);
                    pripojModel(); //volání metody pro zachájení připojení přes Bluetooth
                    Toast toast = Toast.makeText(getApplicationContext(), "Vyberte zařízení pro komunikaci s Bluetooth", Toast.LENGTH_LONG);
                    toast.show();
                }
            }
        });
    }

    //metoda, která podle výběru spárovaných zařízení připojí dané zařízení k ovladači a přepne na aktivitu ovladac
    private void pripojModel() {
        //Zobrazuje již spárovaná zařízení
        sparovanaZarizeniBluetooth = mBluetoothAdapter.getBondedDevices(); //získání spárovaných zařízení
        zarizeniListBluetooth = new ArrayList();

        if (sparovanaZarizeniBluetooth.size() > 0) {
            for (BluetoothDevice device : sparovanaZarizeniBluetooth) {
                zarizeniListBluetooth.add(device.getName() + "\n" + device.getAddress());
            }
        } else {
            Toast toast = Toast.makeText(getApplicationContext(), "Žádné zařízení k dispozici. Proveďte párování ručně!", Toast.LENGTH_LONG);
            toast.show();
        }
        final ArrayAdapter adapter = new ArrayAdapter(this, android.R.layout.simple_list_item_1, zarizeniListBluetooth); //určení vzhledu seznamu zařízení
        seznamZarizeniBluetooth.setAdapter(adapter);
        seznamZarizeniBluetooth.setOnItemClickListener(listClickListener); //volání naslouchače po zvolení zařízení
    }

    private AdapterView.OnItemClickListener listClickListener = new AdapterView.OnItemClickListener() {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            String info = ((TextView) view).getText().toString(); //získání jména zařízení
            String adresa = info.substring(info.length() - 17); //získání jeho adresy
            Intent i = new Intent(PripojeniBluetooth.this, Ovladac.class); //přesměrování na obrazovku ovladač

            sStartBluetooth = true;
            i.putExtra(EXTRA_ADDRESS_BLUETOOTH, adresa);
            startActivity(i);
        }
    };

    //metoda pro odpojení ovladače
    private void odpojModel() {
        buttonOdpojBluetooth.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mBluetoothAdapter.disable();
                textViewStavPripojBluetooth.setText("Nepřipojeno");
                if (zarizeniListBluetooth.isEmpty()) {
                    seznamZarizeniBluetooth.setVisibility(View.INVISIBLE);
                } else {
                    seznamZarizeniBluetooth.setVisibility(View.INVISIBLE);
                }
            }
        });
    }

}
