package com.example.droptik;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.io.IOException;


public class ZobrazeniSouradnicAuta extends AppCompatActivity {
    //definování proměnných
    protected boolean jeBTPripojen = false; //ověření zda je připojené Bluetooth

    protected TextView textViewStav; //stav připojení Bluetooth
    protected TextView textViewSouradnice; //sem se bude zobrazovat aktuální souřadnice
    //definování potřebných tlačítek
    protected Button buttonStart;
    protected Button buttonSouradniceMapa;
    protected Button buttonVymaz;
    protected Button buttonStop;
    protected Button buttonUloz;
    protected Button buttonZastavUkladani;

    private Nabidka nabidka = new Nabidka();
    private PrenosSouradnicAuta prenosSouradnicAuta = new PrenosSouradnicAuta();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_zobrazeni_souradnic);

        //definování toolbaru pro umístění menu
        Toolbar toolbar = findViewById(R.id.toolSouradnice);
        setSupportActionBar(toolbar);

        textViewStav = findViewById(R.id.txtStavPr);
        //přiřazení TextView pro zobrazení dat
        textViewSouradnice = findViewById(R.id.textSouradnice);

        //přiřazení tlačítek k designu
        buttonStart = findViewById(R.id.btnStarta);
        buttonVymaz = findViewById(R.id.btnVymazat);
        buttonStop = findViewById(R.id.btnStop);
        buttonSouradniceMapa = findViewById(R.id.btnSouradniceMapa);
        buttonUloz = findViewById(R.id.btnUkladaniSouradnic);
        buttonZastavUkladani = findViewById(R.id.btnNeukladat);

        buttonStart.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                prenosSouradnicAuta.zahajPrenos();
            }
        });

        buttonVymaz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (jeBTPripojen) {
                    vymazObrazovku();
                }
            }
        });

        buttonStop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (jeBTPripojen) {
                    try {
                        prenosSouradnicAuta.ukonciPrenos();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        buttonSouradniceMapa.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (jeBTPripojen) {
                prenosSouradnicAuta.prejdiNaMapu();
                }
            }
        });

        buttonUloz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (jeBTPripojen) {
                    prenosSouradnicAuta.ukladejSouradniceNaSD();
                }
            }
        });
        buttonZastavUkladani.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (jeBTPripojen) {
                    prenosSouradnicAuta.zastavUkladaniNaSD();
                }
            }
        });
    }

    //po zvolení prvku z menu přesun na metodu třídy Nabidka pro zobrazení konkrétní obrazovky
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.mePripojeni:
                nabidka.otevriPripojeniBluetooth();
                return true;
            case R.id.meOvladac:
                nabidka.otevriOvladac();
                return true;
            case R.id.meMapa:
                nabidka.otevriMapa();
                return true;
            case R.id.meZobrazeniSouradnic:
                nabidka.otevriZobrazeniSouradnicAuta();
                return true;
            case R.id.meAbout:
                nabidka.otevriAbout();
                return true;
            case R.id.meKonec:
                nabidka.ukoncitProgram();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    //vymazání obrazovky
    private void vymazObrazovku() {
        textViewSouradnice.setText("");
    }

}
